import java.util.*;
import java.io.*;
import java.sql.*;
import javax.mail.*;
import javax.mail.internet.*;
import java.text.*;

public class DelayWarning {

   String db_exception;

    // The connection to the database
    Connection conn;
    String URL="jdbc:oracle:thin:@127.0.0.1:1521:ORADB";
    String USER="user";
    String PASSWORD="password";

    String log_path="../../../UnixStructure/CDR/log";

   public void Init_DB () {

     db_exception="";
     try
     {
	
	// See if we need to open the connection to the database
	if (conn == null)
	{

        // Load the JDBC driver
    	  DriverManager.registerDriver (new oracle.jdbc.OracleDriver());

  	// Connect to the database
	conn = DriverManager.getConnection (URL, USER, PASSWORD);

	}

      }
      catch (Exception e)
      {
        db_exception=e.getMessage();
      }
   }

   public void Close_DB () {
	try
	{
	    if (conn != null)
	    {
		conn.close();
		conn=null;
	    }
	}
	catch (Exception e)
	{
	  db_exception=e.getMessage();
	}
   }   

  public static void main( String... aArguments ){

    DelayWarning emailer = new DelayWarning();
    Calendar cal = Calendar.getInstance();
    BufferedWriter out=null;
    String filename;
    filename=emailer.log_path+"/emailing_";
    SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
    filename=filename+sdf.format(cal.getTime()) + "_";
    sdf = new SimpleDateFormat("hhmmss");
    filename=filename+sdf.format(cal.getTime()) + ".log";

    try {
    		out = new BufferedWriter(new FileWriter(filename));
    }
    catch (IOException e) {
    }

    if (emailer.conn == null) {
	emailer.Init_DB();
    }
    if (emailer.db_exception.equals("")) 
    {
        Statement stmt;
	try
	{

		// Create a statement
		stmt = emailer.conn.createStatement ();
	
        	String query = "SELECT DISTINCT SUBSCRIBED_NAME, SUBSCRIBED_EMAIL, SMS ";
		query = query + "FROM  REF_KPI_SUBSCRIPTION ";
		query = query + "WHERE KPI_ID=-1 ";

		// Execute the query
		ResultSet rset = stmt.executeQuery (query);
	  
		// Dump the result
		while (rset.next ()) {
		      //Processing here
		      String subscribed_name=rset.getString("SUBSCRIBED_NAME");
		      String subscribed_email=rset.getString("SUBSCRIBED_EMAIL");
		      int is_sms=Integer.valueOf(rset.getString("SMS"));
		
		      String subject="";
		      if (is_sms >0) {	
		   	subject="RA KPI DELAY";
		      } else {
		   	subject="[Revenue Assurance KPI] Loading Process still running - KPI evaluation delayed";
		      }
		      String message="";
		      if (is_sms >0) {
				message="Loading proc. still running. KPI evaluation delayed";
		      } else {
			   	message="Dear " + subscribed_name;
			   	message=message+ ",\n\n";
			   	message=message+ "This email is to indicate that the loading process is still running.\n";
			   	message=message+ "Because of this, the KPI email alarms will be sent with some delay.\n";
			   	message=message+"Regards,\n\n";
			   	message=message+"RA Administrator\n";
			   	message=message+"info@proactiveRA.com";

		      }
		      emailer.sendEmail(
      				"info@proactiveRA.com", subscribed_email,
       				 subject, message);
		      if (is_sms > 0) {
				Thread.sleep(1000);
		       }
		       try {
		                String log_line="- Emailing " + subscribed_name + "<" + subscribed_email + ">";
				log_line=log_line+ " about KPI Delay." + "\n";
    				out.write(log_line);
		        } catch (IOException e) {
	    			emailer.db_exception=e.getMessage();
      	    			System.err.println("Cannot send email. " + emailer.db_exception);
		        }
		}
	}
	catch (Exception e)
	{
	    emailer.db_exception=e.getMessage();
      	    System.err.println("Cannot send email. " + emailer.db_exception);
	}	    
    }
    emailer.Close_DB();
    try {
    	out.close();
    } catch (IOException e) {
      emailer.db_exception=e.getMessage();
      System.err.println("Cannot send email. " + emailer.db_exception);
    }

  }

  public void sendEmail(
    String aFromEmailAddr, String aToEmailAddr,
    String aSubject, String aBody
  ){
    Session session = Session.getDefaultInstance( fMailServerConfig, null );
    MimeMessage message = new MimeMessage( session );
    try {
      message.setFrom( new InternetAddress(aFromEmailAddr) );
      message.addRecipient(
        Message.RecipientType.TO, new InternetAddress(aToEmailAddr)
      );
      message.setSubject( aSubject );
      message.setText( aBody );
      Transport.send( message );
    }
    catch (MessagingException ex){
        String exception=ex.getMessage();
        System.err.println("Cannot send email. " + exception);
    }
  }

  public static void refreshConfig() {
    fMailServerConfig.clear();
    fetchConfig();
  }

  private static Properties fMailServerConfig = new Properties();

  static {
    fetchConfig();
  }

    InputStream input = null;
    try {
      //This file contains the javax.mail config properties mentioned above.
      input = new FileInputStream( "./mail.server.properties" );
      fMailServerConfig.load( input );
    }
    catch ( IOException ex ){
      System.err.println("Cannot open and load mail server properties file.");
    }
    finally {
      try {
        if ( input != null ) input.close();
      }
      catch ( IOException ex ){
        System.err.println( "Cannot close mail server properties file." );
      }
    }
  }
} 

