import java.util.*;
import java.io.*;
import java.sql.*;
import javax.mail.*;
import javax.mail.internet.*;
import java.text.*;

public class Emailer {

   String db_exception;
    // The connection to the database
    Connection conn;
    String URL="jdbc:oracle:thin:@127.0.0.1:1521:ORADB";
    String USER="user";
    String PASSWORD="password";

    String log_path="../../../UnixStructure/CDR/log";

   public void Init_DB () {

     db_exception="";
     try
     {
	
	// See if we need to open the connection to the database
	if (conn == null)
	{

        // Load the JDBC driver
    	  DriverManager.registerDriver (new oracle.jdbc.OracleDriver());

  	// Connect to the database
	conn = DriverManager.getConnection (URL, USER, PASSWORD);

	}

      }
      catch (Exception e)
      {
        db_exception=e.getMessage();
      }
   }

   public void Close_DB () {
	try
	{
	    if (conn != null)
	    {
		conn.close();
		conn=null;
	    }
	}
	catch (Exception e)
	{
	  db_exception=e.getMessage();
	}
   }   

  public static void main( String... aArguments ){

    Emailer emailer = new Emailer();
    Calendar cal = Calendar.getInstance();
    BufferedWriter out=null;
    String filename;
    filename=emailer.log_path+"/emailing_";
    SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
    filename=filename+sdf.format(cal.getTime()) + "_";
    sdf = new SimpleDateFormat("hhmmss");
    filename=filename+sdf.format(cal.getTime()) + ".log";

    try {
    		out = new BufferedWriter(new FileWriter(filename));
    }
    catch (IOException e) {
    }

    if (emailer.conn == null) {
	emailer.Init_DB();
    }
    if (emailer.db_exception.equals("")) 
    {
        Statement stmt;
	try
	{

		// Create a statement
		stmt = emailer.conn.createStatement ();
	
        	String query = "SELECT A.KPI_ID, F_KPI_CDR_GETCOLOR(A.KPI_ID) \"COLOR\", B.CALCULATED_VALUE, ";
		query = query + "A.SUBSCRIBED_NAME, A.SUBSCRIBED_EMAIL, A.SUBSCRIBED_LEVEL, A.SMS, ";
		query = query + "C.KPI_NAME, C.VALUE_FORMAT, C.SQL_DYNA_PARAM_NAME, B.PARAM_USED ";
		query = query + "FROM REF_KPI_SUBSCRIPTION A, KPI_CALCULATED_VALUES B, REF_KPI_DEFINITION C ";
		query = query + "WHERE A.KPI_ID=B.KPI_ID ";
		query = query + "AND A.KPI_ID=C.KPI_ID ";
		query = query + "AND A.KPI_ID NOT IN (600) ";
		query = query + "AND A.KPI_ID NOT IN ";
		query = query + "( ";
		query = query + "  SELECT KPI_ID ";
		query = query + "  FROM REF_KPI_ALARM_DEPENDENCY ";
		query = query + "  WHERE DEPENDS_UPON_KPI_ID IN ";
		query = query + "  ( ";
		query = query + "     SELECT KPI_ID ";
		query = query + "     FROM KPI_CALCULATED_VALUES ";
		query = query + "     WHERE KPI_ID IN ";
		query = query + "     ( ";
		query = query + "        SELECT DISTINCT DEPENDS_UPON_KPI_ID ";
		query = query + "        FROM REF_KPI_ALARM_DEPENDENCY ";
		query = query + "     ) ";
		query = query + "     AND F_KPI_CDR_GETCOLOR(KPI_ID) > 1 ";
		query = query + "  ) ";
		query = query + ") ";

		// Execute the query
		ResultSet rset = stmt.executeQuery (query);
	  
		// Dump the result
		while (rset.next ()) {
		      //Processing here
		      Double color=rset.getDouble("COLOR");
		      Double subscribed_level=rset.getDouble("SUBSCRIBED_LEVEL");
		      if (color >= subscribed_level) {
			   Double kpi_id=rset.getDouble("KPI_ID");
			   String kpi_name=rset.getString("KPI_NAME");
			   String subscribed_name=rset.getString("SUBSCRIBED_NAME");
			   String subscribed_email=rset.getString("SUBSCRIBED_EMAIL");
			   Double kpi_value=rset.getDouble("CALCULATED_VALUE");
			   String value_format=rset.getString("VALUE_FORMAT");
			   String param_used=rset.getString("PARAM_USED");
			   String sql_dyna_param_name=rset.getString("SQL_DYNA_PARAM_NAME");
			   int is_sms=Integer.valueOf(rset.getString("SMS"));
		
			   String subject="";
			   if (is_sms >0) {	
			   	subject="RA KPI";
			   } else {
			   	subject="[Revenue Assurance KPI Alarm] " + kpi_name;
			   }
			   String evaluated_color="[GREEN]";
			   if (color.equals(1.0)) {
				evaluated_color="[GREEN]";
			   }
			   if (color.equals(2.0)) {
				evaluated_color="[ORANGE]";
			   }
			   if (color.equals(3.0)) {
				evaluated_color="[RED]";
			   }
			   NumberFormat formatter;
                           String s_value="";
                           if (value_format.equals("H:MI:SS")) {
                                Double duration=kpi_value;
                                Double hour=Math.floor(duration/3600);
                                Double minute=Math.floor((duration-(hour*3600))/60);
                                Double second=duration-(hour*3600)-(minute*60);
                                formatter = new DecimalFormat("00");
                                s_value=formatter.format(hour) + ":" + formatter.format(minute) + ":" + formatter.format(second);
                            } else {
			        formatter = new DecimalFormat(value_format);
				s_value=formatter.format(kpi_value);
			    }

			   String message="";
			   if (is_sms >0) {
				message=kpi_name + " is " + evaluated_color + ". ";
				message=message+"Value: ";
			   	message=message+ s_value;
				message=message+". Param: " + param_used + ".";
			   } else {
			   	message="Dear " + subscribed_name;
			   	message=message+ ",\n\n";
			   	message=message+ "This alarm is to indicate that the following KPI\n";
			   	message=message+ "     \"" + kpi_name + "\"";
			   	message=message+ "\nhas been evaluated to ";
			   	message=message+evaluated_color;
			   	message=message+" with a value of: ";
			   	message=message+ s_value;
			   	message=message+".\nThis KPI value has been calculated for the following criteria:\n";
			   	message=message+"    ( " + sql_dyna_param_name + " = " + param_used + " )\n\n";
			   	message=message+"You can logon the Revenue Assurance Dashboard for more details.\n";
			   	message=message+"Regards,\n\n";
			   	message=message+"RA Dashboard Administrator\n";
			   	message=message+"info@proactiveRA.com";

			   }
			   emailer.sendEmail(
      				"info@proactiveRA.com", subscribed_email,
       				 subject, message);
			   if (is_sms > 0) {
				Thread.sleep(1000);
			   }
			   try {
				String log_line="- Emailing " + subscribed_name + "<" + subscribed_email + ">";
				log_line=log_line+ " about KPI \"" + kpi_name + "\" that has been evaluated ";
				log_line=log_line+ evaluated_color + " with a value of ";
				log_line=log_line+ s_value + "\n";
    				out.write(log_line);
			   } catch (IOException e) {
	    			emailer.db_exception=e.getMessage();
      	    			System.err.println("Cannot send email. " + emailer.db_exception);
			   }
		      }
		}
	}
	catch (Exception e)
	{
	    emailer.db_exception=e.getMessage();
      	    System.err.println("Cannot send email. " + emailer.db_exception);
	}	    
    }
    emailer.Close_DB();
    try {
    	out.close();
    } catch (IOException e) {
      emailer.db_exception=e.getMessage();
      System.err.println("Cannot send email. " + emailer.db_exception);
    }

  }

  public void sendEmail(
    String aFromEmailAddr, String aToEmailAddr,
    String aSubject, String aBody
  ){
    Session session = Session.getDefaultInstance( fMailServerConfig, null );
    MimeMessage message = new MimeMessage( session );
    try {
      message.setFrom( new InternetAddress(aFromEmailAddr) );
      message.addRecipient(
        Message.RecipientType.TO, new InternetAddress(aToEmailAddr)
      );
      message.setSubject( aSubject );
      message.setText( aBody );
      Transport.send( message );
    }
    catch (MessagingException ex){
        String exception=ex.getMessage();
        System.err.println("Cannot send email. " + exception);
    }
  }

  public static void refreshConfig() {
    fMailServerConfig.clear();
    fetchConfig();
  }

  private static Properties fMailServerConfig = new Properties();

  static {
    fetchConfig();
  }

  private static void fetchConfig() {
    InputStream input = null;
    try {
      //This file contains the javax.mail config properties mentioned above.
      input = new FileInputStream( "./mail.server.properties" );
      fMailServerConfig.load( input );
    }
    catch ( IOException ex ){
      System.err.println("Cannot open and load mail server properties file.");
    }
    finally {
      try {
        if ( input != null ) input.close();
      }
      catch ( IOException ex ){
        System.err.println( "Cannot close mail server properties file." );
      }
    }
  }
} 

