#!/usr/bin/ksh

#-----------------------------------------------------------------------------------------
#--
#-- Copyright (c) 2009-2012 ProactiveRA
#--
#-- This script is free software; you can redistribute it and/or modify it under
#-- the terms of the GNU Lesser General Public License as published by the Free
#-- Software Foundation; either version 3 of the License, or (at your option)
#-- any later version.
#--
#-- This script is distributed in the hope that it will be useful, but WITHOUT
#-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
#-- details.
#--
#-- You should have received a copy of the GNU Lesser General Public License
#-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
#--
#-----------------------------------------------------------------------------------------

ra_user=`whoami`

# See if any loading process is still running
process_id=`ps -efl | grep ${ra_user} | grep extract_and_load | grep -v grep  | awk '{print $4}' | tail -1`

if [[ "${process_id}" -ne "" ]]; then
        echo "A loading process is still running!"
	# Sending emails about the delay
	./delay.ksh
        nb_attempts=0
        while [[ ("${process_id}" -ne "") && (nb_attempts -le 10) ]]; do
		# Wait 10 minutes
	        sleep 600

        	echo "Checking if loading process is still running..."
		process_id=`ps -efl | grep ${ra_user} | grep extract_and_load | grep -v grep  | awk '{print $4}' | tail -1`
          	((nb_attempts=nb_attempts+1))
        done
fi
./kpi.ksh -1
./emails.ksh;

