#!/usr/bin/ksh

#-----------------------------------------------------------------------------------------
#--
#-- Copyright (c) 2009-2012 ProactiveRA
#--
#-- This script is free software; you can redistribute it and/or modify it under
#-- the terms of the GNU Lesser General Public License as published by the Free
#-- Software Foundation; either version 3 of the License, or (at your option)
#-- any later version.
#--
#-- This script is distributed in the hope that it will be useful, but WITHOUT
#-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
#-- details.
#--
#-- You should have received a copy of the GNU Lesser General Public License
#-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
#--
#-----------------------------------------------------------------------------------------

. ../Common/extract_dir_local.ksh
. ../Common/extract_dir_remote.ksh
. ../Common/extract_oracle_database.ksh
. ../Common/extract_remote_host.ksh
. ../Common/extract_java.ksh
. ../Common/extract_multiple.ksh

function extract_common {

  start_and_prepare_extract_logfile $2
  print_header $2
  validate_RA_DB_available
  if [ $abort = 0 ]; then

      # No Error - Continue
      get_last_extract_dt $2

      if [ $abort = 0 ]; then

        # No Error - Continue
	if [[ $1 == *database* ]] 
	then
		subsource=''
		if [ $3 ]
		then
			subsource=$3
		fi
		$1 $2 '*' $subsource
		set 'extract_dir_local' $2 $3
		no_duplicate_check[$2]="Yes"
	fi
        nb_file=0
        if [[ $MODULE = "CDR" ]]; then  
		$1 $2 '*'
	else
        	while read line ; do
	  		file_pattern=`echo $line | sed 's/\(.*\);\(.*\);\(.*\)/\1/'`
			$1 $2 ${file_pattern}
		done < ${resource_dir}/${main_directory[$2]}/datasource.resource
        fi

        if [[ $nb_file = 0 ]];then
                echo "    <<No File Extracted>>"
                echo "    <<No File Extracted>>" >> $logfile
        else
                echo "  --------------------------------"
                echo "  --------------------------------" >> $logfile
                echo "  Nb Files Extracted: ${nb_file}"
                echo "  Nb Files Extracted: ${nb_file}" >> $logfile
        fi
        echo "  --------------------------------"
        echo "  --------------------------------" >> $logfile
        echo "  Done."
        echo "  Done." >> $logfile 
        echo ""
        echo "" >> $logfile  

        update_last_extract_dt $2

      fi   #-- Retreiving the Last Extract Dt

  fi   #-- Verifying the availability of RA database
  finish_log_and_end

}

