#!/usr/bin/ksh

#-----------------------------------------------------------------------------------------
#--
#-- Copyright (c) 2009-2012 ProactiveRA
#--
#-- This script is free software; you can redistribute it and/or modify it under
#-- the terms of the GNU Lesser General Public License as published by the Free
#-- Software Foundation; either version 3 of the License, or (at your option)
#-- any later version.
#--
#-- This script is distributed in the hope that it will be useful, but WITHOUT
#-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
#-- details.
#--
#-- You should have received a copy of the GNU Lesser General Public License
#-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
#--
#-----------------------------------------------------------------------------------------

function extract_SQLServerDB {

   JAVA_UID="${SQLS_UID[$1]}"
   JAVA_PASS="${SQLS_PASS[$1]}"
   JAVA_URL="${SQLS_URL[$1]}"
   JAVA_CLASS="java_extract_SQLSERVER"

   extract_java $1
}

#-----------------------------------------------------------------------------------------

function extract_MySQLDB {

   JAVA_UID="${MYSQL_UID[$1]}"
   JAVA_PASS="${MYSQL_PASS[$1]}"
   JAVA_URL="${MYSQL_URL[$1]}"
   JAVA_CLASS="java_extract_MYSQL"

   extract_java $1

}

#-----------------------------------------------------------------------------------------

function extract_java {

  #----------------------------------------------------------------------
  #-- Extract proc to be used when a java-class is available to connect 
  #-- to an external database, run a query and produce an ASCII extract
  #----------------------------------------------------------------------

  command_line="java ${JAVA_CLASS} ${JAVA_UID} ${JAVA_PASS} ${JAVA_URL} "
  command_line="${command_line} ${extract_query_dir}/${main_directory[$1]}/extract";
  if [ $3 ]
  then
	command_line="${command_line}_${2}"
  fi
  command_line="${command_line}.sql ${main_dir}/extracted/${main_directory[$1]}/${result_file[$1]} "
  command_line="${command_line} ${last_extract_dt}"

  result=`$command_line`

}

