#!/usr/bin/ksh

#-----------------------------------------------------------------------------------------
#--
#-- Copyright (c) 2009-2012 ProactiveRA
#--
#-- This script is free software; you can redistribute it and/or modify it under
#-- the terms of the GNU Lesser General Public License as published by the Free
#-- Software Foundation; either version 3 of the License, or (at your option)
#-- any later version.
#--
#-- This script is distributed in the hope that it will be useful, but WITHOUT
#-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
#-- details.
#--
#-- You should have received a copy of the GNU Lesser General Public License
#-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
#--
#-----------------------------------------------------------------------------------------

. ../Common/lib.ksh
. ../Common/extract_common.ksh
. ../Common/extract_multiple.ksh

function extract_menu {

#identify if we need to run in batch mode or interactive mode
if [[ $# = 0 ]];then
    running_mode=interactive
else
    running_mode=batch
fi

init_global_variables
read_resource_file
SOURCE="            (Extract Script Menu)            ";

choice=-1

if [[ $running_mode = "batch" ]];then
	if [[ "${extract_method[$choice]}" = "extract_multiple" ]]; then
		${extract_method[$choice]} $choice;
	else
		extract_common ${extract_method[$1]} $1;
	fi
else

    while [ $choice -ne 0 ]
    do
        display_sources
        read choice

        if [[ $choice = 0 ]]; then
	    clear;
	    exit 1;
        fi
        if [[ $choice == +([0-9]) ]]; then
              if [[ $choice -le $nbsources ]]; then
		       if [[ "${extract_method[$choice]}" = "extract_multiple" ]]; then
	               		${extract_method[$choice]} $choice;
		       else
	               		extract_common ${extract_method[$choice]} $choice;
		       fi
              else	
  	               clear; 
	               echo "Wrong option entered"; 
	               echo "Press Enter"; 
	               read unused; 
	               choice=-1;
              fi
        else
              clear; 
              echo "Wrong option entered"; 
              echo "Press Enter"; 
              read unused; 
              choice=-1;
        fi
    done
fi

}
