#!/usr/bin/ksh

#-----------------------------------------------------------------------------------------
#--
#-- Copyright (c) 2009-2012 ProactiveRA
#--
#-- This script is free software; you can redistribute it and/or modify it under
#-- the terms of the GNU Lesser General Public License as published by the Free
#-- Software Foundation; either version 3 of the License, or (at your option)
#-- any later version.
#--
#-- This script is distributed in the hope that it will be useful, but WITHOUT
#-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
#-- details.
#--
#-- You should have received a copy of the GNU Lesser General Public License
#-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
#--
#-----------------------------------------------------------------------------------------


function extract_multiple {

  #----------------------------------------------------------------------
  #-- Extract proc to be used when a Data-Mediation system is 
  #-- pushing the files into the local RA directory for processing
  #-- (i.e. files can be moved/deleted by the script)
  #---------------------------------------------------------------

  saved_running_mode="${running_mode}";
  if [[ $running_mode = "interactive" ]];then
     clear
  fi
  running_mode="batch";

  subsource_id=800;
  while [[ ${subsource_id} -le $nbsubsources ]]; do
	if [[ ${parentsource[${subsource_id}]} = $1 ]]; then
		source_name[${subsource_id}]=${source_name[$1]};
		main_directory[${subsource_id}]=${main_directory[$1]};
		extract_common ${extract_method[${subsource_id}]} $1 ${subsourceid[${subsource_id}]};
	fi
	((subsource_id=subsource_id+1));
  done
  
  running_mode="${saved_running_mode}";

  if [[ $running_mode = "interactive" ]];then
     echo "Press Enter to return to the main menu"
     read unused
  fi

}
