#!/usr/bin/ksh

#-----------------------------------------------------------------------------------------
#--
#-- Copyright (c) 2009-2012 ProactiveRA
#--
#-- This script is free software; you can redistribute it and/or modify it under
#-- the terms of the GNU Lesser General Public License as published by the Free
#-- Software Foundation; either version 3 of the License, or (at your option)
#-- any later version.
#--
#-- This script is distributed in the hope that it will be useful, but WITHOUT
#-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
#-- details.
#--
#-- You should have received a copy of the GNU Lesser General Public License
#-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
#--
#-----------------------------------------------------------------------------------------

. ./lib.ksh

while read line ; do
        PASS_RA=$line;
done < .PASS_RA

while read line ; do
        PASS_LIFERAY=$line;
done < .PASS_LIFERAY

param_files[1]=structure_only.dat
param_title[1]=STRUCTURE
param_files[2]=reference_tables.dat
param_title[2]=REF
param_files[3]=biv_tables.dat
param_title[3]=BIV
param_files[4]=cdr_summary_tables.dat
param_title[4]=CDR_SUMMARY
param_files[5]=cdr_tables.dat
param_title[5]=CDR
param_files[6]=cdr_last_event.dat
param_title[6]=CDR_LAST_EVENT
param_files[7]=structure_dbd.dat
param_title[7]=STRUCTURE_DBD
param_files[8]=kpi_tables.dat
param_title[8]=KPI
param_files[9]=sdr_tables.dat
param_title[9]=SDR

#############################

function export_db {

date=$(date +%Y%m%d_%H%M%S)
logfile=export_${date}.log

exp ${UID_RA}/${PASS_RA}@${DB_RA} PARFILE=param_files/${param_files[$1]} FILE=data_files/export_${param_title[$1]}_${date}.dat LOG=log/${logfile}

echo "  --------------------------------"
echo "  Done."
echo "Press Enter";

read unused
}

#############################

function export_dashboard_db {

date=$(date +%Y%m%d_%H%M%S)
logfile=export_${date}.log

exp ${UID_LIFERAY}/${PASS_LIFERAY}@${DB_RA} PARFILE=param_files/${param_files[$1]} FILE=data_files/export_${param_title[$1]}_${date}.dat LOG=log/${logfile}

echo "  --------------------------------"
echo "  Done."
echo "Press Enter";

read unused
}

#############################

choice=-1


while [ $choice -ne 0 ]
do

clear
echo ""; echo ""; echo ""
echo "    ###############################################"
echo "    #                                             #"
echo "    #            - REVENUE ASSURANCE -            #"
echo "    #                Slice Utility                #"
echo "    #                                             #"
echo "    ###############################################"
echo ""
echo ""
echo "Available Options:"
echo "------------------"
echo "  1)  Database structure of RA user (All Objects, No Rows)"
echo "  2)  Configuration tables (REF_)"
echo "  3)  Billing Validation Tables (BIV_)"
echo "  4)  CDR Summary Stats (CDR_ALL*)"
echo "  5)  CDR tables (CDR_)"
echo "  6)  CDR_LAST_EVENT"
echo "  7)  Database structure of Dashboard (LIFERAY) user (All Objects, All Data)"
echo "  8)  KPI tables (*KPI*)"
echo "  9)  SDR tables (*SDR*)"

echo ""
echo "  0) Cancel"
echo ""
echo "Select your option: "
read choice


if [[ $choice = 0 ]]; then
        clear;
        exit 1;
fi
if [[ $choice == +([0-9]) ]]; then
   if [[ $choice -lt 10 ]]; then
	if [[ $choice = 7 ]]; then
        	export_dashboard_db $choice;
	else
        	export_db $choice;
	fi
   else
        clear;
        echo "Wrong option entered";
        echo "Press Enter";
        read unused;
        choice=-1;
   fi
else
   clear;
   echo "Wrong option entered";
   echo "Press Enter";
   read unused;
   choice=-1;
fi

done
